/* "Copyright (C) 2015 L.N. van Vliet
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY. See the Short Open License for more 
 * details: http://www.tinkerist.com/sol/"
*/


//int seed = 0; for(i=0; i<16; i++) { seed = (seed << 1) | (read_adc() & 1) }

// hints:
// use (0 or EXIT_SUCCESS) and (EXIT_FAILURE) for return codes
// for delays, use _delay_us and _delay_ms in avr/delay.h

// don't use these definitions---v, use the aliases.
#define INPUTX(port,pin) DDR ## port &= ~_BV(pin)		// Set as input
#define OUTPUTX(port,pin) DDR ## port |= _BV(pin)		// Set as output
#define SETX(port,pin) PORT ## port |= _BV(pin) 		// Set pull-up
#define CLEARX(port,pin) PORT ## port &= ~_BV(pin) 		// Clear pull-up
#define LOWX(port,pin) PORT ## port &= ~_BV(pin)		// Set low
#define HIGHX(port,pin) PORT ## port |= _BV(pin)		// Set high
#define TOGGLEX(port,pin) PORT ## port ^= _BV(pin)		// Switch high/low
#define READX(port,pin) ((PIN ## port & _BV(pin))?1:0)	// Test value
// uses these aliases---v 
#define INPUT(x) INPUTX(x)								// Alias of Set as input
#define OUTPUT(x) OUTPUTX(x)							// Alias of Set as output
#define LOW(x) LOWX(x)									// Alias of Set low
#define HIGH(x) HIGHX(x)								// Alias of Set high
#define TOGGLE(x) TOGGLEX(x)							// Alias of Switch high to low or vice versa
#define READ(x) READX(x)								// Alias of Returns bit, 0 or 1
#define PULLUP_ON(x) INPUTX(x); SETX(x)					// Alias of Set as input, pull-up resistor enabled
#define PULLUP_OFF(x) INPUTX(x); CLEARX(x)				// Alias of Set as input, pull-up resistor disabled
#define OUT_HI(x) OUTPUTX(x); HIGHX(x)					// Alias of Set as output and set high
#define OUT_LO(x) OUTPUTX(x); LOWX(x)					// Alias of Set as output and set low

#define LED1			D,0					// LED 1
#define LED2			D,1					// LED 2
#define LED3			D,2					// LED 3
#define LED4			D,3					// LED 4
#define LED5			D,4					// LED 5
#define LED6			B,6					// LED 6
#define LED7			B,7					// LED 7
#define LED8			D,5					// LED 8
#define LED9			D,6					// LED 9
#define LED10			D,7					// LED 10
#define LED11			B,0					// LED 11
#define LED12			B,1					// LED 12
#define LED13			B,2					// LED 13
#define LED14			C,0					// LED 14
#define LED15			C,1					// LED 15
#define LED16			C,2					// LED 16
#define LED17			C,3					// LED 17
#define LED18			C,4					// LED 18
#define LED19			C,5					// LED 19


#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sfr_defs.h>


#define sbi(port,bit) (port) |= (1 << (bit)) 
#define cbi(port,bit) (port) &= ~(1 << (bit))
#define inp(port) (port)
#define bit_is_set(sfr, bit) (_SFR_BYTE(sfr) & _BV(bit))
#define bit_is_clear(sfr, bit) (!(_SFR_BYTE(sfr) & _BV(bit)))
#define loop_until_bit_is_set(sfr, bit) do { } while (bit_is_clear(sfr, bit))
#define loop_until_bit_is_clear(sfr, bit) do { } while (bit_is_set(sfr, bit))


void _delay_ms(int msec) {
    int i,j;
    for (i=0; i<msec;i++){
        for (j=0; j<15; j++)
            {asm ("nop"); }
    }
}

void patt_random(unsigned long delay_value)
{
	uint8_t i = 0;
	int irnd = 0;
	for (i=1;i<20;i++){
		irnd = (rand()/(RAND_MAX / 19 + 1) );
		switch(irnd) {
			case 1: TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED1); break;
			case 2: TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED2); break;
			case 3: TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED3); break;
			case 4: TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED4); break;
			case 5: TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED5); break;
			case 6: TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED6); break;
			case 7: TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED7); break;
			case 8: TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED8); break;
			case 9: TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED9); break;
			case 10: TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED10); break;
			case 11: TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED11); break;
			case 12: TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED12); break;
			case 13: TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED13); break;
			case 14: TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED14); break;
			case 15: TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED15); break;
			case 16: TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED16); break;
			case 17: TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED17); break;
			case 18: TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED18); break;
			case 19: TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED19); break;
		}
	}
}


void patt_reverse(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<20;i++){
		switch(i) {
			case 1: TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED19); break;
			case 2: TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED18); break;
			case 3: TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED17); break;
			case 4: TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED16); break;
			case 5: TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED15); break;
			case 6: TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED14); break;
			case 7: TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED13); break;
			case 8: TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED12); break;
			case 9: TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED11); break;
			case 10: TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED10); break;
			case 11: TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED9); break;
			case 12: TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED8); break;
			case 13: TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED7); break;
			case 14: TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED6); break;
			case 15: TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED5); break;
			case 16: TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED4); break;
			case 17: TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED3); break;
			case 18: TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED2); break;
			case 19: TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED1); break;
		}
	}
}


void patt_linear(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<20;i++){
		switch(i) {
			case 1: TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED1); break;
			case 2: TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED2); break;
			case 3: TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED3); break;
			case 4: TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED4); break;
			case 5: TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED5); break;
			case 6: TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED6); break;
			case 7: TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED7); break;
			case 8: TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED8); break;
			case 9: TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED9); break;
			case 10: TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED10); break;
			case 11: TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED11); break;
			case 12: TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED12); break;
			case 13: TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED13); break;
			case 14: TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED14); break;
			case 15: TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED15); break;
			case 16: TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED16); break;
			case 17: TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED17); break;
			case 18: TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED18); break;
			case 19: TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED19); break;	
		}
	}
}


void patt_opposite(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<20;i++){
		switch(i) {
			case 1: TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED1); break;
			case 2: TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED18); break;
			case 3: TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED3); break;
			case 4: TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED16); break;
			case 5: TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED5); break;
			case 6: TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED14); break;
			case 7: TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED7); break;
			case 8: TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED12); break;
			case 9: TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED9); break;
			case 10: TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED10); break;
			case 11: TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED11); break;
			case 12: TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED8); break;
			case 13: TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED13); break;
			case 14: TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED6); break;
			case 15: TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED15); break;
			case 16: TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED4); break;
			case 17: TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED17); break;
			case 18: TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED2); break;
			case 19: TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED19); break;	
		}
	}
}


void patt_opposite_bytwo_mirror(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<20;i++){
		switch(i) {
			case 1: TOGGLE(LED1); TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED1); TOGGLE(LED19); break;
			case 2: TOGGLE(LED2); TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED2); TOGGLE(LED18); break;
			case 3: TOGGLE(LED3); TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED3); TOGGLE(LED17); break;
			case 4: TOGGLE(LED4); TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED4); TOGGLE(LED16); break;
			case 5: TOGGLE(LED5); TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED5); TOGGLE(LED15); break;
			case 6: TOGGLE(LED6); TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED6); TOGGLE(LED14); break;
			case 7: TOGGLE(LED7); TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED7); TOGGLE(LED13); break;
			case 8: TOGGLE(LED8); TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED8); TOGGLE(LED12); break;
			case 9: TOGGLE(LED9); TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED9); TOGGLE(LED11); break;
			case 10: TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED10); break;
			case 11: TOGGLE(LED11); TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED11); TOGGLE(LED9); break;
			case 12: TOGGLE(LED12); TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED12); TOGGLE(LED8); break;
			case 13: TOGGLE(LED13); TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED13); TOGGLE(LED7); break;
			case 14: TOGGLE(LED14); TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED14); TOGGLE(LED6); break;
			case 15: TOGGLE(LED15); TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED15); TOGGLE(LED5); break;
			case 16: TOGGLE(LED16); TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED16); TOGGLE(LED4); break;
			case 17: TOGGLE(LED17); TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED17); TOGGLE(LED3); break;
			case 18: TOGGLE(LED18); TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED18); TOGGLE(LED2); break;
			case 19: TOGGLE(LED19); TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED19); TOGGLE(LED1); break;
		}
	}
}


void patt_opposite_byfive(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<20;i++){
		switch(i) {
			case 1: TOGGLE(LED1); TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED1); TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17); break;
			case 2: TOGGLE(LED2); TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED2); TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18); break;
			case 3: TOGGLE(LED3); TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED3); TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19); break;
			case 4: TOGGLE(LED4); TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED4); TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1); break;
			case 5: TOGGLE(LED5); TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED5); TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2); break;
			case 6: TOGGLE(LED6); TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED6); TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3); break;
			case 7: TOGGLE(LED7); TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED7); TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4); break;
			case 8: TOGGLE(LED8); TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED8); TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5); break;
			case 9: TOGGLE(LED9); TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED9); TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6); break;
			case 10: TOGGLE(LED10); TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED10); TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7); break;
			case 11: TOGGLE(LED11); TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED11); TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8); break;
			case 12: TOGGLE(LED12); TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED12); TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9); break;
			case 13: TOGGLE(LED13); TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED13); TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10); break;
			case 14: TOGGLE(LED14); TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED14); TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11); break;
			case 15: TOGGLE(LED15); TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED15); TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12); break;
			case 16: TOGGLE(LED16); TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED16); TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13); break;
			case 17: TOGGLE(LED17); TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED17); TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14); break;
			case 18: TOGGLE(LED18); TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED18); TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15); break;
			case 19: TOGGLE(LED19); TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED19); TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16); break;
		}
	}
}


void patt_opposite_byfive_reverse(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<20;i++){
		switch(i) {
			case 1: TOGGLE(LED19); TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED19); TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16); break;
			case 2: TOGGLE(LED18); TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED18); TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15); break;
			case 3: TOGGLE(LED17); TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED17); TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14); break;
			case 4: TOGGLE(LED16); TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED16); TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13); break;
			case 5: TOGGLE(LED15); TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED15); TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8);  TOGGLE(LED12); break;
			case 6: TOGGLE(LED14); TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED14); TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7);  TOGGLE(LED11); break;
			case 7: TOGGLE(LED13); TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED13); TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6);  TOGGLE(LED10); break;
			case 8: TOGGLE(LED12); TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED12); TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5);  TOGGLE(LED9); break;
			case 9: TOGGLE(LED11); TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED11); TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4);  TOGGLE(LED8); break;
			case 10: TOGGLE(LED10); TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED10); TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3);  TOGGLE(LED7); break;
			case 11: TOGGLE(LED9); TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED9); TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2);  TOGGLE(LED6); break;
			case 12: TOGGLE(LED8); TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED8); TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1);  TOGGLE(LED5); break;
			case 13: TOGGLE(LED7); TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED7); TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19);  TOGGLE(LED4); break;
			case 14: TOGGLE(LED6); TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED6); TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18);  TOGGLE(LED3); break;
			case 15: TOGGLE(LED5); TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED5); TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17);  TOGGLE(LED2); break;
			case 16: TOGGLE(LED4); TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED4); TOGGLE(LED8);  TOGGLE(LED12);  TOGGLE(LED16);  TOGGLE(LED1); break;
			case 17: TOGGLE(LED3); TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED3); TOGGLE(LED7);  TOGGLE(LED11);  TOGGLE(LED15);  TOGGLE(LED19); break;
			case 18: TOGGLE(LED2); TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED2); TOGGLE(LED6);  TOGGLE(LED10);  TOGGLE(LED14);  TOGGLE(LED18); break;
			case 19: TOGGLE(LED1); TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED1); TOGGLE(LED5);  TOGGLE(LED9);  TOGGLE(LED13);  TOGGLE(LED17); break;
		}
	}
}


void patt_odd(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<11;i++){
		switch(i) {
			case 1: TOGGLE(LED1); _delay_ms(delay_value); TOGGLE(LED1); break;
			case 2: TOGGLE(LED3); _delay_ms(delay_value); TOGGLE(LED3); break;
			case 3: TOGGLE(LED5); _delay_ms(delay_value); TOGGLE(LED5); break;
			case 4: TOGGLE(LED7); _delay_ms(delay_value); TOGGLE(LED7); break;
			case 5: TOGGLE(LED9); _delay_ms(delay_value); TOGGLE(LED9); break;
			case 6: TOGGLE(LED11); _delay_ms(delay_value); TOGGLE(LED11); break;
			case 7: TOGGLE(LED13); _delay_ms(delay_value); TOGGLE(LED13); break;
			case 8: TOGGLE(LED15); _delay_ms(delay_value); TOGGLE(LED15); break;
			case 9: TOGGLE(LED17); _delay_ms(delay_value); TOGGLE(LED17); break;
			case 10: TOGGLE(LED19); _delay_ms(delay_value); TOGGLE(LED19); break;	
		}
	}
}


void patt_even(unsigned long delay_value)
{
	uint8_t i = 0;
	for (i=1;i<10;i++){
		switch(i) {
			case 1: TOGGLE(LED2); _delay_ms(delay_value); TOGGLE(LED2); break;
			case 2: TOGGLE(LED4); _delay_ms(delay_value); TOGGLE(LED4); break;
			case 3: TOGGLE(LED6); _delay_ms(delay_value); TOGGLE(LED6); break;
			case 4: TOGGLE(LED8); _delay_ms(delay_value); TOGGLE(LED8); break;
			case 5: TOGGLE(LED10); _delay_ms(delay_value); TOGGLE(LED10); break;
			case 6: TOGGLE(LED12); _delay_ms(delay_value); TOGGLE(LED12); break;
			case 7: TOGGLE(LED14); _delay_ms(delay_value); TOGGLE(LED14); break;
			case 8: TOGGLE(LED16); _delay_ms(delay_value); TOGGLE(LED16); break;
			case 9: TOGGLE(LED18); _delay_ms(delay_value); TOGGLE(LED18); break;
		}
	}
}


void define_outputs()
{
	OUTPUT(LED1);
	OUTPUT(LED2);
	OUTPUT(LED3);
	OUTPUT(LED4);
	OUTPUT(LED5);
	OUTPUT(LED6);
	OUTPUT(LED7);
	OUTPUT(LED8);
	OUTPUT(LED9);
	OUTPUT(LED10);
	OUTPUT(LED11);
	OUTPUT(LED12);
	OUTPUT(LED13);
	OUTPUT(LED14);
	OUTPUT(LED15);
	OUTPUT(LED16);
	OUTPUT(LED17);
	OUTPUT(LED18);
	OUTPUT(LED19);
}

void run_patterns()
{
	unsigned long irnd = 0;
	unsigned long dv = 0;
	srand(10);
	while(1) {
		irnd = (rand()/(RAND_MAX / 14 + 1) * 1 );
		dv = (rand()/(RAND_MAX / 14 + 1) * 1 );
		switch(irnd) {
			case 1: patt_even(dv); break;
			case 2: patt_linear(dv); break;
			case 3: patt_reverse(dv); break;
			case 4: patt_opposite(dv); break;
			case 5: patt_odd(dv); break;
			case 6: patt_random(dv); break;
			case 7: patt_opposite_bytwo_mirror(dv); break;
			case 8: patt_opposite_byfive(dv); break;
			case 9: patt_opposite_byfive_reverse(dv); break;
			case 10: patt_opposite_byfive(dv); patt_opposite_byfive_reverse(dv); break;
			case 11: patt_opposite_byfive_reverse(dv); patt_opposite_byfive_reverse(dv); break;
			case 12: patt_opposite_byfive_reverse(dv); patt_opposite_byfive_reverse(dv); break;
			case 13: patt_linear(dv); patt_reverse(dv); break;
			case 14: patt_odd(dv); patt_even(dv); break;			
		}	
	}
}


int main(void)
{	
    // Enable Global Interrupts
    // sei();
	define_outputs();
	unsigned long irnd;
	unsigned long dv;
	srand(189);
	while(1) {
		irnd = (rand()/(RAND_MAX / 10 + 1) );
		dv = (rand()/(RAND_MAX / 10 + 1) )*1000;
		switch(irnd) {
			case 1: patt_random(dv); break;
			case 2: patt_linear(dv); break;
			case 3: patt_reverse(dv); break;
			case 4: patt_opposite(dv); break;
			case 5: patt_odd(dv); break;
			case 6: patt_even(dv); break;
			case 7: patt_opposite_bytwo_mirror(dv); break;
			case 8: patt_opposite_byfive(dv); break;
			case 9: patt_opposite_byfive_reverse(dv); break;
			case 10: patt_opposite_byfive(dv); patt_opposite_byfive_reverse(dv); break;
		}
	}
}

		
/*
 * End
 */
